sview/statistics/__init__.py
from .views import statistics
from .tasks import suggest_aggregation  # noqa: F401
from .tasks import Aggregation  # noqa: F401
from .tasks import RESOURCE_QUERIES  # noqa: F401
from .tasks import suggest_caching  # noqa: F401
from .tasks import suggest_caching_period  # noqa: F401
from .tasks import Resource  # noqa: F401
from .tasks import QUARTERLY_PERIOD, HOURLY_PERIOD, DAILY_PERIOD  # noqa: F401
from .tasks import PERIODS, AGGREGATION_PERIODS  # noqa: F401

sview/statistics/tasks/__init__.py
from .aggregation import suggest_aggregation  # noqa: F401
from .aggregation import Aggregation  # noqa: F401
from .exceptions import ResourceError  # noqa: F401
from .queries import RESOURCE_QUERIES  # noqa: F401
from .queries import KNOWN_PARAMS  # noqa: F401
from .periods import PERIODS, DEFAULT_PERIOD, AGGREGATION_PERIODS  # noqa: F401
from .periods import QUARTERLY_PERIOD, HOURLY_PERIOD, DAILY_PERIOD  # noqa: F401
from .resources import get_resource  # noqa: F401
from .resources import suggest_caching  # noqa: F401
from .resources import suggest_caching_period  # noqa: F401
from .resources import Resource  # noqa: F401

sview/statistics/tasks/periods/__init__.py
from .time import MINUTE
from .time import MINUTE15
from .time import MINUTE30
from .time import HOUR
from .time import HOUR3
from .time import HOUR6
from .time import DAY
from .time import WEEK
from .time import MONTH
from .time import MONTH3
from .time import YEAR


class PriorityQueue:
    AGGREGATION = "aggregation"
    QUICK_CACHE = "quick-cache"
    SLOW_CACHE = "slow-cache"


"""Time periods for data aggregation
"""
#  Not a real aggregation period. It just marks data with no aggregation
NATIVE_PERIOD = {
    "handle": "",
    "source_period": None,
}
QUARTERLY_PERIOD = {
    "handle": "quarterly",
    "source_period": NATIVE_PERIOD,
    "queue": PriorityQueue.AGGREGATION,
    "bucket": "15 minutes",
    "start_delay_bonus": 3 * 60,  # seconds
    "refresh_interval": MINUTE15,
    "display_interval": MINUTE15,
    "last_ts_before_function": "ts_last_quarter_before",
    "index": 1,
}
HOURLY_PERIOD = {
    "handle": "hourly",
    "source_period": QUARTERLY_PERIOD,
    "queue": PriorityQueue.AGGREGATION,
    "bucket": "1 hour",
    "start_delay_bonus": 10,  # seconds
    "refresh_interval": HOUR,
    "display_interval": HOUR,
    "last_ts_before_function": "ts_last_hour_before",
    "index": 2,
}
DAILY_PERIOD = {
    "handle": "daily",
    "source_period": HOURLY_PERIOD,
    "queue": PriorityQueue.AGGREGATION,
    "bucket": "1 day",
    "start_delay_bonus": 10,  # seconds
    "refresh_interval": DAY,
    "display_interval": DAY,
    "last_ts_before_function": "ts_last_midnight_before",
    "index": 3,
}

AGGREGATION_PERIODS = {
    "quarterly": QUARTERLY_PERIOD,
    "hourly": HOURLY_PERIOD,
    "daily": DAILY_PERIOD,
}


"""Time periods of displayed data. If you divide period length by length of
flux window, you will get the number of displayed data points. Each period has
defined cache TTL. It seems reasonable for TTL to be half a length of flux
window. Cache TTL is defined in seconds and should be used on both server and
client sides.
"""
PERIOD_HOUR = {
    "handle": "1h",
    "label": "Hour",
    "bucket": "1 minute",
    "start_delay_bonus": 0,  # seconds
    "cache_ttl": 5 * 60,
    "user_cache_ttl": 30,  # should not be high - user could keep outdated data
    "source_period": NATIVE_PERIOD,
    "queue": PriorityQueue.QUICK_CACHE,
    "refresh_interval": MINUTE,
    "display_interval": HOUR,
    "last_ts_before_function": "ts_last_minute_before",
    "index": 1,
}
PERIOD_6_HOURS = {
    "handle": "6h",
    "label": "6 Hours",
    "bucket": "15 minutes",
    "start_delay_bonus": 5,  # seconds
    "cache_ttl": 25 * 60,
    "user_cache_ttl": 2 * 60,
    "source_period": QUARTERLY_PERIOD,
    "queue": PriorityQueue.QUICK_CACHE,
    "refresh_interval": MINUTE15,
    "display_interval": HOUR6,
    "last_ts_before_function": "ts_last_quarter_before",
    "index": 2,
}
PERIOD_DAY = {
    "handle": "1d",
    "label": "Day",
    "bucket": "30 minutes",
    "start_delay_bonus": 5,  # seconds
    "cache_ttl": 50 * 60,
    "user_cache_ttl": 5 * 60,
    "source_period": QUARTERLY_PERIOD,
    "queue": PriorityQueue.QUICK_CACHE,
    "refresh_interval": MINUTE30,
    "display_interval": DAY,
    "last_ts_before_function": "ts_last_half_before",
    "index": 3,
}
PERIOD_WEEK = {
    "handle": "1w",
    "label": "Week",
    "bucket": "3 hours",
    "start_delay_bonus": 5,  # seconds
    "cache_ttl": 4 * 60 * 60,
    "user_cache_ttl": 5 * 60,
    "source_period": HOURLY_PERIOD,
    "queue": PriorityQueue.SLOW_CACHE,
    "refresh_interval": HOUR3,
    "display_interval": WEEK,
    "last_ts_before_function": "ts_last_3hour_before",
    "index": 4,
}
PERIOD_MONTH = {
    "handle": "1m",
    "label": "Month",
    "bucket": "1 day",
    "start_delay_bonus": 5,  # seconds
    "cache_ttl": 25 * 60 * 60,
    "user_cache_ttl": 5 * 60,
    "source_period": DAILY_PERIOD,
    "queue": PriorityQueue.SLOW_CACHE,
    "refresh_interval": DAY,
    "display_interval": MONTH,
    "last_ts_before_function": "ts_last_midnight_before",
    "index": 5,
}
PERIOD_3_MONTHS = {
    "handle": "3m",
    "label": "3 Months",
    "bucket": "2 days",
    "start_delay_bonus": 5,  # seconds
    "cache_ttl": 25 * 60 * 60,
    "user_cache_ttl": 5 * 60,
    "source_period": DAILY_PERIOD,
    "queue": PriorityQueue.SLOW_CACHE,
    "refresh_interval": DAY,
    "display_interval": MONTH3,
    "last_ts_before_function": "ts_last_midnight_before",
    "index": 6,
}
PERIOD_YEAR = {
    "handle": "1y",
    "label": "Year",
    "bucket": "14 days",
    "start_delay_bonus": 5,  # seconds
    "cache_ttl": 25 * 60 * 60,
    "user_cache_ttl": 5 * 60,
    "source_period": DAILY_PERIOD,
    "queue": PriorityQueue.SLOW_CACHE,
    "refresh_interval": DAY,
    "display_interval": YEAR,
    "last_ts_before_function": "ts_last_midnight_before",
    "index": 7,
}


DEFAULT_PERIOD = "1w"

PERIODS = {
    "1h": PERIOD_HOUR,
    "6h": PERIOD_6_HOURS,
    "1d": PERIOD_DAY,
    "1w": PERIOD_WEEK,
    "1m": PERIOD_MONTH,
    "3m": PERIOD_3_MONTHS,
    "1y": PERIOD_YEAR,
}

sview/statistics/views.py
import re

from flask import jsonify
from flask import render_template
from flask import Blueprint
from flask import redirect
from flask import request
from flask import session
from flask import url_for
from flask_breadcrumbs import default_breadcrumb_root, register_breadcrumb

from .tasks import ResourceError
from .tasks import get_resource
from .tasks import PERIODS, DEFAULT_PERIOD
from .tasks import KNOWN_PARAMS
from .tasks.task_helpers import base64_decode
from .tasks.task_helpers import is_ip
from .view_helpers import get_tokens_hash
from .view_helpers import endpoint_arguments_constructor

statistics = Blueprint("statistics", __name__)
default_breadcrumb_root(statistics, ".")

DEVICE_TOKEN_CHARS = "^[a-z0-9]*$"
DEVICE_TOKEN_LENGTH = 64


@statistics.route("/")
@register_breadcrumb(
    statistics,
    ".",
    "Threat Detection",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def dashboard():
    page_title = "Overview"
    resource_names = [
        "all_countries_by_incidents_list",
        "all_attackers_graph",
        "all_incidents_graph",
        "top_countries_by_incidents_list",
        "top_passwords_by_usages_list",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(url_for(request.endpoint, period=DEFAULT_PERIOD))

    params = {"period": period}

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/dashboard.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/attackers/")
@register_breadcrumb(
    statistics,
    ".attacker",
    "Attackers",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def attackers():
    page_title = "Attackers"
    resource_names = [
        "all_countries_by_attackers_list",
        "all_attackers_graph",
        "top_countries_by_attackers_graph",
        "top_countries_by_attackers_list_long",
        "top_attackers_by_incidents_list_long",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(url_for(request.endpoint, period=DEFAULT_PERIOD))

    params = {"period": period}

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/attackers.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/attackers/details/ip/<string:ip>")
@register_breadcrumb(
    statistics,
    ".attacker.ip",
    "Attacker Details",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def attacker_details(ip):
    page_title = "Attacker Details"
    resource_names = [
        "selected_attacker_incidents_graph",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(url_for(request.endpoint, ip=ip, period=DEFAULT_PERIOD))

    if not is_ip(ip):
        return "Not a valid IPv4 address", 400

    params = {
        "period": period,
        "ip": ip,
    }

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/attacker_details.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/passwords/")
@register_breadcrumb(
    statistics,
    ".passwords",
    "Passwords",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def passwords():
    page_title = "Passwords"
    resource_names = [
        "top_passwords_by_usages_graph",
        "top_passwords_by_usages_list_long",
        "top_usernames_by_usages_list_long",
        "top_combinations_by_usages_list_long",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(url_for(request.endpoint, period=DEFAULT_PERIOD))

    params = {"period": period}

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/passwords.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/passwords/details/<string:encoded_password>")
@register_breadcrumb(
    statistics,
    ".passwords.details",
    "Password Details",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def password_details(encoded_password):
    page_title = "Password Details"
    password = base64_decode(encoded_password)
    if not password:
        return "Unable to decode password", 400

    resource_names = [
        "logins_of_password_by_usages_list",
        "selected_password_by_usages_graph",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(
            url_for(
                request.endpoint,
                encoded_password=encoded_password,
                period=DEFAULT_PERIOD,
            )
        )

    params = {
        "period": period,
        "password": password,
    }

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/password_details.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/incidents/")
@register_breadcrumb(
    statistics,
    ".incidents",
    "Incidents",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def incidents():
    page_title = "Incidents"
    resource_names = [
        "all_countries_by_incidents_list",
        "all_incidents_graph",
        "top_countries_by_incidents_list",
        "top_incident_types_by_incidents_list",
        "top_countries_by_incidents_graph",
        "top_traps_by_incidents_graph",
        "top_actions_by_incidents_graph",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(url_for(request.endpoint, period=DEFAULT_PERIOD))

    params = {"period": period}

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/incidents.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/ports/")
@register_breadcrumb(
    statistics,
    ".ports",
    "Ports",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def ports():
    page_title = "Ports"
    resource_names = [
        "all_ports_by_scans_graph",
        "top_ports_by_scans_list_long",
        "top_ports_by_scans_graph",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(url_for(request.endpoint, period=DEFAULT_PERIOD))

    params = {"period": period}

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/ports.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/devices/")
@register_breadcrumb(
    statistics,
    ".devices",
    "My Devices",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def devices():
    page_title = "My Devices"
    resource_names = [
        "my_all_incidents_graph",
        "my_top_traps_by_incidents_graph",
        "my_top_countries_by_incidents_graph",
    ]
    tokens_hash = get_tokens_hash(session.get("devices"))

    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(
            url_for(request.endpoint, period=DEFAULT_PERIOD, token=tokens_hash)
        )

    if tokens_hash != request.args.get("token"):
        return redirect(url_for(request.endpoint, period=period, token=tokens_hash))

    params = (
        {"period": period, "token": tokens_hash} if tokens_hash else {"period": period}
    )

    tokens = tuple(session.get("devices", []))

    resources = {
        resource_name: get_resource(
            resource_name, {**params, "my_device_tokens": tokens}
        )
        for resource_name in resource_names
    }

    return render_template(
        "statistics/devices.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/api/resource")
def get_resource_view():
    resource_name = request.args.get("name")
    if resource_name is None:
        return jsonify({"error": "No resource name provided."})

    params = {}
    for param_name, default_value in KNOWN_PARAMS.items():
        param = request.args.get(param_name, default_value)
        if param is not None:
            params[param_name] = param

    if "devices" in session:
        params["my_device_tokens"] = tuple(session["devices"])

    try:
        data = get_resource(resource_name, params)
    except ResourceError as exc:
        return jsonify({"error": str(exc)})

    response = jsonify(
        {
            "resource_name": resource_name,
            "data": data,
        }
    )

    if data is not None:

sview/templates/statistics/attacker_details.html
{%- from "_snippets.html" import data_box with context -%}
{%- from "_snippets.html" import pair_data_box with context -%}
{%- from "_snippets.html" import button_line_box with context -%}
{%- from "_snippets.html" import line_box with context -%}
{%- from "_snippets.html" import country_code_item with context -%}
{%- from "_snippets.html" import request_missing_resources with context -%}
{% extends "layout.html" %}
{% block body %}
<h1 class="mb-3">{{ active_params["ip"] }}</h1>
<p>
    <a href="https://client.rdap.org/?type=ip&object={{ active_params["ip"] }}" target="rdap" rel="nofollow noreferrer">
        Lookup for IP address details<sup><i class="fas fa-external-link-alt fa-xs ml-1"></i></sup>
    </a>
</p>
<div class="row">
    <div class="col">
        {{ button_line_box("selected_attacker_incidents_graph", "Attacker activity", periods,
        active_params, resources["selected_attacker_incidents_graph"], "bucket", "count", "Events")
        }}
    </div>
</div>
{{ request_missing_resources(resource_names, resources, active_params) }}
{% endblock %}

sview/templates/statistics/attackers.html
{%- from "_snippets.html" import data_box with context -%}
{%- from "_snippets.html" import pair_data_box with context -%}
{%- from "_snippets.html" import map_box with context -%}
{%- from "_snippets.html" import line_box with context -%}
{%- from "_snippets.html" import country_code_item with context -%}
{%- from "_snippets.html" import big_period_buttons with context -%}
{%- from "_snippets.html" import request_missing_resources with context -%}
{% extends "layout.html" %}
{% block body %}
<div class="row">
	<div class="col mb-4">
		{{ map_box(
			"all_countries_by_attackers_list",
			"Countries by unique attackers",
			resources["all_countries_by_attackers_list"],
			"attackers"
		) }}
	</div>
</div>
<div class="row">
	{{ big_period_buttons(resource_names, periods, active_params) }}
</div>
<div class="row">
	<div class="col">
		{{ line_box("all_attackers_graph", "Number of unique attackers during the time", resources["all_attackers_graph"], "bucket", "count", "Unique IP addresses") }}
	</div>
</div>
<div class="row">
	<div class="col-md">
		{% call(data_item) data_box("top_countries_by_attackers_list_long", "Top countries by unique attackers", resources["top_countries_by_attackers_list_long"], "country") -%}
			{{ country_code_item(data_item) }}
		{%- endcall %}
	</div>
	<div class="col-md">
		{% call(data_item) data_box("top_attackers_by_incidents_list_long", "Top attackers by recorded incidents", resources["top_attackers_by_incidents_list_long"], "ip") -%}
			<a href="{{ url_for("statistics.attacker_details", ip=data_item, period=active_params['period']) }}">
				{{ data_item }}
			</a>
		{%- endcall %}
	</div>
</div>
<div class="row">
	<div class="col">
		{{ line_box(
			"top_countries_by_attackers_graph",
			"Top countries by unique attackers",
			resources["top_countries_by_attackers_graph"]["data"],
			"bucket",
			resources["top_countries_by_attackers_graph"]["ykeys"],
			resources["top_countries_by_attackers_graph"]["labels"]
		) }}
	</div>
</div>
{{ request_missing_resources(resource_names, resources, active_params) }}
{% endblock %}

sview/templates/statistics/dashboard.html
{%- from "_snippets.html" import data_box with context -%}
{%- from "_snippets.html" import pair_data_box with context -%}
{%- from "_snippets.html" import map_box with context -%}
{%- from "_snippets.html" import line_box with context -%}
{%- from "_snippets.html" import country_code_item with context -%}
{%- from "_snippets.html" import big_period_buttons with context -%}
{%- from "_snippets.html" import request_missing_resources with context -%}
{% extends "layout.html" %}
{% block body %}
<div class="row">
	<div class="col mb-4">
		{{ map_box(
			"all_countries_by_incidents_list",
			"Countries by incidents",
			resources["all_countries_by_incidents_list"],
			"incidents"
		) }}
	</div>
</div>
<div class="row">
	{{ big_period_buttons(resource_names, periods, active_params) }}
</div>
<div class="row">
	<div class="col">
		{{ line_box("all_attackers_graph", "Number of unique attackers during the time", resources["all_attackers_graph"], "bucket", "count", "Unique IP addresses") }}
	</div>
</div>
<div class="row">
	<div class="col">
		{{ line_box("all_incidents_graph", "Number of recorded incidents during the time", resources["all_incidents_graph"], "bucket", "count", "Incidents") }}
	</div>
</div>
<div class="row">
	<div class="col-md">
		{% call(data_item) data_box("top_countries_by_incidents_list", "Top countries by recorded incidents", resources["top_countries_by_incidents_list"], "country") -%}
			{{ country_code_item(data_item) }}
		{%- endcall %}
	</div>
	<div class="col-md">
		{% call(data_item) data_box("top_passwords_by_usages_list", "Most abused passwords", resources["top_passwords_by_usages_list"], "password") %}
			<a href="{{ url_for("statistics.password_details", encoded_password=data_item|b64, period=active_params['period']) }}">
				{{ data_item }}
			</a>
		{% endcall %}
	</div>
</div>
{{ request_missing_resources(resource_names, resources, active_params) }}
{% endblock %}

sview/templates/statistics/devices.html
{%- from "_snippets.html" import data_box with context -%}
{%- from "_snippets.html" import pair_data_box with context -%}
{%- from "_snippets.html" import line_box with context -%}
{%- from "_snippets.html" import country_code_item with context -%}
{%- from "_snippets.html" import big_period_buttons with context -%}
{%- from "_snippets.html" import request_missing_resources with context -%}
{% extends "layout.html" %}
{% block body %}
<div class="row">
	<div class="col" >
		<div class="card mb-4 shadow-sm">
			<div class="card-body">
				<h5 class="card-title">My devices</h5>
				<table class="table table-borderless mb-0">
					<tbody>
						<tr class="{{'border-bottom' if session['devices'] }}">
							<form action="/api/device/add" method="post">
								<td>
									<label for="inputDeviceToken" class="sr-only">Device Token</label>
									<input type="text" class="form-control period_form_field" name="period" value="{{ active_params['period'] }}" hidden>
									<input type="text" class="form-control" name="device_token" id="inputDeviceToken" placeholder="Device token" required pattern="^[a-z0-9]*$" minlength="64" maxlength="64" aria-describedby="inputDeviceTokenHelp" autofocus>
									<small id="inputDeviceTokenHelp" class="form-text text-muted">
										Your device token must be 64 characters long, contain letters and numbers, and must not contain spaces, special characters, or emoji.
									</small>
								</td>
								<td class="text-right">
									<button type="submit" class="btn btn-outline-success mb-2 btn-block">Add<span class="d-none d-lg-inline"> device</span></button>
								</td>
							</form>
						</tr>
						{% for device_token in session["devices"] %}
						<tr>
							<form action="/api/device/delete" method="post">
								<td>
									<div class="input-group">
									<label for="inputDeviceToken" class="sr-only">Device Token</label>
									<input type="text" class="form-control period_form_field" name="period" value="{{ active_params['period'] }}" hidden>
									<input type="text" class="form-control " name="device_token" id="inputDeviceToken" placeholder={{ device_token }} value={{ device_token }} readonly>
									</div>
								</td>
								<td class="text-right">
									<button type="submit" class="btn btn-outline-danger btn-block">Remove<span class="d-none d-lg-inline"> device</span></button>
								</td>
							</form>
						</tr>
						{% endfor %}
					</tbody>
				</table>
			</div>
		</div>
	</div>
</div>
<div class="row">
	{{ big_period_buttons(resource_names, periods, active_params) }}
</div>
<div class="row">
	<div class="col">
		{{ line_box(
			"my_all_incidents_graph",
			"All incidents recorded on my devices",
			resources["my_all_incidents_graph"],
			"bucket",
			"count",
			"Incidents"
		) }}
	</div>
</div>
<div class="row">
	<div class="col">
		{{ line_box(
			"my_top_traps_by_incidents_graph",
			"Top traps by incidents recorded on my devices",
			resources["my_top_traps_by_incidents_graph"]["data"],
			"bucket",
			resources["my_top_traps_by_incidents_graph"]["ykeys"],
			resources["my_top_traps_by_incidents_graph"]["labels"],
		) }}
	</div>
</div>
<div class="row">
	<div class="col">
		{{ line_box(
			"my_top_countries_by_incidents_graph",
			"Top countries by incidents recorded on my devices",
			resources["my_top_countries_by_incidents_graph"]["data"],
			"bucket",
			resources["my_top_countries_by_incidents_graph"]["ykeys"],
			resources["my_top_countries_by_incidents_graph"]["labels"],
		) }}
	</div>
</div>
{{ request_missing_resources(resource_names, resources, active_params) }}
{% endblock %}

sview/templates/statistics/incidents.html
{%- from "_snippets.html" import data_box with context -%}
{%- from "_snippets.html" import pair_data_box with context -%}
{%- from "_snippets.html" import map_box with context -%}
{%- from "_snippets.html" import line_box with context -%}
{%- from "_snippets.html" import country_code_item with context -%}
{%- from "_snippets.html" import big_period_buttons with context -%}
{%- from "_snippets.html" import request_missing_resources with context -%}
{% extends "layout.html" %}
{% block body %}
<div class="row">
    <div class="col mb-4">
        {{ map_box(
            "all_countries_by_incidents_list",
            "Countries by recorded incidents",
            resources["all_countries_by_incidents_list"],
            "incidents"
        ) }}
    </div>
</div>
<div class="row">
    {{ big_period_buttons(resource_names, periods, active_params) }}
</div>
<div class="row">
    <div class="col">
        {{ line_box("all_incidents_graph", "Number of recorded incidents during the time", resources["all_incidents_graph"], "bucket", "count", "Incidents") }}
    </div>
</div>
<div class="row">
    <div class="col-md">
        {% call(data_item) data_box("top_countries_by_incidents_list", "Top countries by recorded incidents", resources["top_countries_by_incidents_list"], "country") -%}
            {{ country_code_item(data_item) }}
        {%- endcall %}
    </div>
    <div class="col-md">
        {{ pair_data_box("top_incident_types_by_incidents_list", "Top incident types by recorded incidents", resources["top_incident_types_by_incidents_list"], "source", "action") }}
    </div>
</div>
<div class="row">
    <div class="col">
        {{ line_box(
            "top_countries_by_incidents_graph",
            "Top countries by recorded incidents",
            resources["top_countries_by_incidents_graph"]["data"],
            "bucket",
            resources["top_countries_by_incidents_graph"]["ykeys"],
            resources["top_countries_by_incidents_graph"]["labels"] ) }}
    </div>
</div>
<div class="row">
    <div class="col">
        {{ line_box(
            "top_traps_by_incidents_graph",
            "Top traps by recorded incidents",
            resources["top_traps_by_incidents_graph"]["data"],
            "bucket",
            resources["top_traps_by_incidents_graph"]["ykeys"],
            resources["top_traps_by_incidents_graph"]["labels"]
        ) }}
    </div>
</div>
<div class="row">
    <div class="col">
        {{ line_box(
            "top_actions_by_incidents_graph",
            "Top actions by recorded incidents",
            resources["top_actions_by_incidents_graph"]["data"],
            "bucket",
            resources["top_actions_by_incidents_graph"]["ykeys"],
            resources["top_actions_by_incidents_graph"]["labels"]
        ) }}
    </div>
</div>
{{ request_missing_resources(resource_names, resources, active_params) }}
{% endblock %}